//package com.tanpu.community.service;
//
//import com.google.common.collect.Lists;
//import org.springframework.beans.BeanUtils;
//import org.springframework.util.CollectionUtils;
//
//import java.util.List;
//import java.util.Map;
//import java.util.stream.Collectors;
//
//public class ProductService {
//
//    /**
//     * 获取资源信息
//     *
//     * @param shortVideoMap
//     * @param curriculumMap
//     * @param zhiboMap
//     * @param fundMap
//     */
//    private void getResInfo(Map<String, ShortVideoBaseInfoResp> shortVideoMap,
//                            Map<String, ShortVideoBaseInfoResp> curriculumMap,
//                            Map<String, ZhiboListResp> zhiboMap,
//                            Map<String, FundInfoBaseResp> fundMap,
//                            List<NewsFeedRes> newsFeedRes,
//                            Map<String, NewsFeedRes> newFeedMap
//    ) {
//        // 白名单基金id
//        List<String> tanpuFundIds = Lists.newArrayList();
//        // 私募基金id
//        List<String> fundIds = Lists.newArrayList();
//        // 理财师导入
//        List<String> ifaFundIds = Lists.newArrayList();
//        // 公募基金id
//        List<String> publicFundIds = Lists.newArrayList();
//        // 无净值产品id
//        List<String> notNetFundIds = Lists.newArrayList();
//        // 短视频id
//        List<String> shortVideoIds = Lists.newArrayList();
//        // 直播id
//        List<String> zhiboIds = Lists.newArrayList();
//        // 课程id
//        List<String> curriculumIds = Lists.newArrayList();
//        // 获取关联资源id
//        if (newsFeedRes != null) {
//
//        }
//        if (!CollectionUtils.isEmpty(shortVideoIds)) {
//            // 短视频列表
//        }
//        if (!CollectionUtils.isEmpty(curriculumIds)) {
//            // 课程列表
//        }
//        if (!CollectionUtils.isEmpty(zhiboIds)) {
//            // 直播列表
//        }
//        this.getFundInfo(tanpuFundIds, fundIds, publicFundIds, ifaFundIds, notNetFundIds, fundMap);
//    }
//
//    /**
//     * 设置产品信息
//     *
//     * @param tanpuFundIds
//     * @param fundIds
//     * @param publicFundIds
//     * @param fundMap
//     */
//    private void getFundInfo(List<String> tanpuFundIds,
//                             List<String> fundIds,
//                             List<String> publicFundIds,
//                             List<String> ifaFundIds,
//                             List<String> notNetFundIds,
//                             Map<String, FundInfoBaseResp> fundMap) {
//        Map<String, FundInfoBaseResp> tampFundMap = null;
//        Map<String, FundInfoBaseResp> privateFundMap = null;
//        Map<String, FundInfoBaseResp> publicFundMap = null;
//        Map<String, FundInfoBaseResp> ifaFundMap = null;
//        Map<String, FundInfoBaseResp> notNetFundMap = null;
//        if (!CollectionUtils.isEmpty(tanpuFundIds)) {
////            ProductListReq productListReq = ProductListReq.builder()
////                    .fundIds(Lists.newArrayList(tanpuFundIds))
////                    .build();
//            // 探普产品
//            CommonResp<List<ProductInfoVO>> commonResp = feignForProduct.getProductInfoByIds(tanpuFundIds);
//            if (commonResp.isSuccess() && !CollectionUtils.isEmpty(commonResp.getAttributes())) {
//                List<FundInfoBaseResp> fundInfoBaseRespList = commonResp.attributes.stream().map(item -> {
//                    FundInfoBaseResp fundInfoBaseResp = FundInfoBaseResp.builder().build();
//                    BeanUtils.copyProperties(item, fundInfoBaseResp);
//                    return fundInfoBaseResp;
//                }).collect(Collectors.toList());
//                tampFundMap = fundInfoBaseRespList.stream().collect(Collectors.toMap(FundInfoBaseResp::getFundId, item -> item));
//            }
//
//            if (tampFundMap != null && tampFundMap.size() > 0) {
//                fundMap.putAll(tampFundMap);
//            }
//        }
//        // 私募产品
//        if (!CollectionUtils.isEmpty(fundIds)) {
//            // 私募产品
//            CommonResp<List<ProductInfoVO>> fundResult = feignForFund.getProductList(fundIds);
//            if (fundResult.isSuccess() && !CollectionUtils.isEmpty(fundResult.getAttributes())) {
//                List<FundInfoBaseResp> fundInfoBaseRespList = fundResult.attributes.stream().map(item -> {
//                    FundInfoBaseResp fundInfoBaseResp = FundInfoBaseResp.builder().build();
//                    BeanUtils.copyProperties(item, fundInfoBaseResp);
//                    return fundInfoBaseResp;
//                }).collect(Collectors.toList());
//                privateFundMap = fundInfoBaseRespList.stream().collect(Collectors.toMap(FundInfoBaseResp::getFundId, item -> item));
//            }
//
//            if (privateFundMap != null && privateFundMap.size() > 0) {
//                fundMap.putAll(privateFundMap);
//            }
//        }
//
//        // 理财师导入产品
//        if (!CollectionUtils.isEmpty(ifaFundIds)) {
//            CommonResp<List<ProductInfoVO>> ifaFundResult = feignForFund.getPrivateFundList(ifaFundIds);
//            if (ifaFundResult.isSuccess() && !CollectionUtils.isEmpty(ifaFundResult.getAttributes())) {
//                List<FundInfoBaseResp> fundInfoBaseRespList = ifaFundResult.attributes.stream().map(item -> {
//                    FundInfoBaseResp fundInfoBaseResp = FundInfoBaseResp.builder().build();
//                    BeanUtils.copyProperties(item, fundInfoBaseResp);
//                    return fundInfoBaseResp;
//                }).collect(Collectors.toList());
//                ifaFundMap = fundInfoBaseRespList.stream().collect(Collectors.toMap(FundInfoBaseResp::getFundId, item -> item));
//            }
//
//            if (ifaFundMap != null && ifaFundMap.size() > 0) {
//                fundMap.putAll(ifaFundMap);
//            }
//        }
//
//        if (!CollectionUtils.isEmpty(publicFundIds)) {
//            // 公募产品
//            CommonResp<List<ProductInfoVO>> publicFundResult = feignForPublicFund.getProductList(publicFundIds);
//            if (publicFundResult.isSuccess() && !CollectionUtils.isEmpty(publicFundResult.getAttributes())) {
//                List<FundInfoBaseResp> fundInfoBaseRespList = publicFundResult.attributes.stream().map(item -> {
//                    FundInfoBaseResp fundInfoBaseResp = FundInfoBaseResp.builder().build();
//                    BeanUtils.copyProperties(item, fundInfoBaseResp);
//                    return fundInfoBaseResp;
//                }).collect(Collectors.toList());
//                publicFundMap = fundInfoBaseRespList.stream().collect(Collectors.toMap(FundInfoBaseResp::getFundId, item -> item));
//            }
//            if (publicFundMap != null && publicFundMap.size() > 0) {
//                fundMap.putAll(publicFundMap);
//            }
//        }
//
//        if (!CollectionUtils.isEmpty(notNetFundIds)) {
//            // 无净值产品
//            CommonResp<List<ProductInfoVO>> notNetInfoResult = feignForFund.getProductListNotNetInfo(notNetFundIds);
//            if (notNetInfoResult.isSuccess() && !CollectionUtils.isEmpty(notNetInfoResult.getAttributes())) {
//                List<FundInfoBaseResp> fundInfoBaseRespList = notNetInfoResult.attributes.stream().map(item -> {
//                    FundInfoBaseResp fundInfoBaseResp = FundInfoBaseResp.builder().build();
//                    BeanUtils.copyProperties(item, fundInfoBaseResp);
//                    return fundInfoBaseResp;
//                }).collect(Collectors.toList());
//                notNetFundMap = fundInfoBaseRespList.stream().collect(Collectors.toMap(FundInfoBaseResp::getFundId, item -> item));
//            }
//            if (notNetFundMap != null && notNetFundMap.size() > 0) {
//                fundMap.putAll(notNetFundMap);
//            }
//        }
//    }
//
//    /**
//     * 设置资源信息
//     *
//     * @param item
//     * @param resp
//     * @param newFeedMap
//     * @param shortVideoMap
//     * @param curriculumMap
//     * @param zhiboMap
//     * @param fundMap
//     */
//    private void setResInfo(NewsFeed item,
//                            NewsFeedResp resp,
//                            Map<String, NewsFeedRes> newFeedMap,
//                            Map<String, ShortVideoBaseInfoResp> shortVideoMap,
//                            Map<String, ShortVideoBaseInfoResp> curriculumMap,
//                            Map<String, ZhiboListResp> zhiboMap,
//                            Map<String, FundInfoBaseResp> fundMap) {
//        if (newFeedMap.containsKey(item.getId())) {
//            NewsFeedRes nf = newFeedMap.get(item.getId());
//            if (nf.getRelType().equals(RelTypeEnum.LIVE.type)) {
//                if (zhiboMap.containsKey(nf.getRemark())) {
//                    ZhiboListResp zhibo = zhiboMap.get(nf.getRemark());
//                    zhibo.setParentId(zhibo.getParentId());
//                    zhibo.setId(zhibo.getId());
//                    resp.setResList(RelContentResp.builder()
//                            .relType(RelTypeEnum.LIVE.type)
//                            .zhibo(zhibo).build());
//                }
//            } else if (nf.getRelType().equals(RelTypeEnum.SHORT_VIDEO.type)) {
//                if (shortVideoMap.containsKey(nf.getRelId())) {
//                    resp.setResList(RelContentResp.builder()
//                            .relType(RelTypeEnum.SHORT_VIDEO.type)
//                            .shortVideo(shortVideoMap.get(nf.getRelId())).build());
//                }
//            } else if (nf.getRelType().equals(RelTypeEnum.VIDEO.type) || nf.getRelType().equals(RelTypeEnum.AUDIO.type)) {
//                if (curriculumMap.containsKey(nf.getRelId())) {
//                    resp.setResList(RelContentResp.builder()
//                            .relType(curriculumMap.get(nf.getRelId()).getRelType())
//                            .curriculum(curriculumMap.get(nf.getRelId())).build());
//                }
//            } else if (nf.getRelType().equals(RelTypeEnum.FUND.type)) {
//                if (fundMap.containsKey(nf.getRelId())) {
//                    FundInfoBaseResp product = fundMap.get(nf.getRelId());
//                    // 推荐语
//                    product.setRemark(nf.getRemark());
//                    // 产品类型
//                    product.setProductType(nf.getProductType());
//                    resp.setResList(RelContentResp.builder()
//                            .relType(RelTypeEnum.FUND.type)
//                            .product(product).build());
//                }
//            }
//        }
//    }
//}
